
// NOTE: This overflow detection does not follow the overflow detection in
//       factorial.asm. In fact, when gcc compiles this code, it does not use
//       the mull instruction. It actually does 64-bit multiplies (for which
//       there is not an x86-32 instruction). GCC emulates 64-bit multiply

int factorial(int num, unsigned long long *res) {
	*res = num;
	int overflow = 0;
	while (num > 1) {

		if (*res > *(unsigned int*)res) {
			overflow = 1;
		}

		*res *= num-1;
		num--;
	}
	return overflow;
}